/*
    Copyright (C) 2001, 2002 Stephane Magnenat
    for any question or comment contact us at nct@ysagoon.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. | See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA | 02111-1307 | USA
*/

#ifndef __SPLINEEDITOR_H
#define __SPLINEEDITOR_H

#include "SDL.h"
#include <GL/gl.h>
#include "SplineHighMap.h"

class SplineEditor
{
protected:
	SDL_Surface *screen;
	// definitions in centimeter
	float eyeX, eyeY, eyeZ, screenSize;
	GLuint texture;
	SplineHeightMap heightmap;
	int editX, editY;
	bool useStereo;
	int triangleRes;
	bool canUseStereo;
	unsigned int landscapeList;
	unsigned int pointerList;
	float rot;
	bool useRotation;

public:
	SplineEditor(float eyeX, float eyeY, float eyeZ, float screenSize, int res=0);
	~SplineEditor();
	int run(void);

protected:
	bool init(void);

	//void regenerateMasks(void);
	void prepareStencilBuffer(void);
	void setProjectionMatrix(bool useStereo, bool side=false);
	void setMask(bool useStereo, bool side=false);
	bool setTexture(const char *filename);
	bool setVideoMode(int w, int h);
	void renderTetrahedre(void);
	void renderLandscape(void);
	void renderLight(void);
	void generateLists(void);
	void setMaterial(float r, float g, float b);
	void renderScene(void);
	void saveBitmaps(void);
	void screenshot(const char *filename);
};

#endif
